<?php
/**

 * the class MyEducationPath implements API functionality for education providers
 * the class requires an API key to work. The key can be get on http://myeducationpath.com 

 */
class MyEducationPath {
	var $apiendpoint='http://myeducationpath.com/api/';
	var $apikey='';
	var $error='';
	var $templateid='0';
	var $courseidtype='local';
	var $emailuser=false;
	
	function __construct($apikey='')
	{
		$this->apikey=$apikey;
	}
	function checkAPIKey(){
		$resp=$this->executeAPICall('getAccountInfo');
		if($resp->status!='ok') return false;
		return true;
	}
	function executeAPICall($function,$options=''){
		$url=$this->apiendpoint.$function.'/'.urlencode($this->apikey).'/';
		$url.='?'.$options;

		$result=file_get_contents($url);
	
		$r=json_decode($result);
		if($r->status!='ok'){
			$this->error=$r->statusmessage;
		}else{
			$this->error='';
		}
		return $r;
	}
	function setTemplateID($id){
		$this->templateid=$id;
	}
	function setEmailUser($s){
		$this->emailuser=$s;
	}
	function setCourseType($t){
		if($t!='local') $t='remote';
		$this->courseidtype=$t;
	}
	function getCertificates(){
		$resp=$this->executeAPICall('getCertificates');
		return $resp->response->certificates;		
	}
	function getTemplates(){
		$resp=$this->executeAPICall('getTemplates');
		return $resp->response->templates;		
	}
	
	function getCertificate($id){
		$resp=$this->executeAPICall('getCertificate','id='.$id);
		return $resp->response->certificate;		
	}	

	function addCertificate($courseid,$email,$name,$date,$code='',$programshort='',$hours='',$enddate='',$grade='',$teacher='',$courseidtype=''){
		if($courseidtype=='') $courseidtype=$this->courseidtype;
		$options='email='.urlencode($email).
			'&code='.urlencode($code).
			'&name='.urlencode($name).
			'&date='.urlencode($date).
			'&program='.urlencode($program).
			'&programshort='.urlencode($programshort).
			'&coursehours='.urlencode($hours).
			'&enddate='.urlencode($enddate).
			'&grade='.urlencode($grade).
			'&teacher='.urlencode($teacher).
			'&templateid='.urlencode($this->templateid).
			'&courseid='.urlencode($courseid).
			'&emailuser='.($this->emailuser?'y':'n').
			'&courseidtype='.$courseidtype;
		$resp=$this->executeAPICall('addCertificate',$options);

		if($resp->status=='ok') return $resp->response->certificate;
		return false;
	}
	
	function removeCertificate($certificateid){
		$options='id='.urlencode($certificateid);
		$resp=$this->executeAPICall('deletecertificate',$options);
		if($resp->status=='ok') return true;
		return false;
	}
	function getPrintCertificateLink($certificateid){
		$options='id='.urlencode($certificateid);
		$resp=$this->executeAPICall('getcertificate',$options);
		if($resp->status=='ok') $resp->response->certificate->printlink;
		return '';
	}
}

?>